package Staartvin.SimpleRegister.Application;

import java.util.List;

import org.bukkit.command.CommandSender;

import Staartvin.SimpleRegister.SimpleRegister;
import Staartvin.SimpleRegister.FileHandling.MessagesFile.configMessages;

public class DeclineApplication {
	
	public SimpleRegister plugin;

	public DeclineApplication(SimpleRegister plugin) {
		this.plugin = plugin;
	}
	
	public void declineApplication(CommandSender sender, String[] args) {
		
		final String name;
		
		if (args.length == 3) {
			name = args[2];
		}
		else {
			name = args[0];
		}
		plugin.methods.callDeclinedEvent(name, sender.getName());
		
		if (plugin.isDeclineApplicationCancelled) {
			return;
		}
		
		if (plugin.playersConfig.getStringList("DeclinedApplications").contains(name.toLowerCase())) {
			sender.sendMessage(plugin.messagesFile.getMessage(configMessages.ALREADY_DECLINED, name, null));
			return;
		}
		else if (plugin.playersConfig.getStringList("PendingApplications").contains(name.toLowerCase())) {
			
			List<String> pendingapplications = plugin.playersConfig.getStringList(
					"PendingApplications");
			pendingapplications.remove(name.toLowerCase());
			plugin.playersConfig.set("PendingApplications", pendingapplications);
			
			List<String> declinedapplications = plugin.playersConfig.getStringList(
					"DeclinedApplications");
			declinedapplications.add(name.toLowerCase());
			plugin.playersConfig.set("DeclinedApplications", declinedapplications);
			plugin.playersConfig.set(name.toLowerCase() + ".Status", "declined");
			plugin.loadConfiguration.saveRegistrationsConfig();
			plugin.methods.getFormatedTextMob(plugin.getConfig().getStringList("CommandsToExecuteOnDecline"), name);
			
			sender.sendMessage(plugin.messagesFile.getMessage(configMessages.DECLINE_APPLICATION, name, null));
			return;
		}
		else {
			sender.sendMessage(plugin.messagesFile.getMessage(configMessages.CANNOT_FIND_APPLICATION_BECAUSE_NO_PENDING, name, null));
			return;
		}
	}
}
