package Staartvin.SimpleRegister.Events;

import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class DeclineApplicationEvent extends Event{
	// This is the player who got declined
	private String declinedPlayer;

	// This is the player who is declining another player
	private String decliningPlayer;

	private boolean isCancelled = false;
	private static final HandlerList handlers = new HandlerList();

	public DeclineApplicationEvent(String playerWhoGotDeclined,
			String playerWhoDeclined) {
		this.declinedPlayer = playerWhoGotDeclined;
		this.decliningPlayer = playerWhoDeclined;
	}

	public HandlerList getHandlers() {
		return handlers;
	}

	public static HandlerList getHandlerList() {
		return handlers;
	}

	/**
	 * Gets the player who got declined
	 * 
	 * @return name of the player who got declined.
	 */
	public String getDeclinedPlayer() {
		return declinedPlayer;
	}

	/**
	 * Gets the player who declined the registration
	 * 
	 * @return name of the player who declined the registration.
	 */
	public String getDecliningPlayer() {
		return decliningPlayer;
	}

	public boolean isCancelled() {
		return isCancelled;
	}

	public void isCancelled(boolean state) {
		isCancelled = state;
	}
}
