package Staartvin.SimpleRegister.FileHandling;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Arrays;
import java.util.List;
import java.util.logging.Level;


import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import Staartvin.SimpleRegister.SimpleRegister;

public class LoadConfiguration {

	SimpleRegister plugin;
	private String[] stringArray = {};
	
	public LoadConfiguration(SimpleRegister plugin) {
		this.plugin = plugin;
	}
	
	// Player Config Methods
		public void reloadRegistrationsConfig() {
			if (plugin.playersConfigFile == null) {
				plugin.playersConfigFile = new File(plugin.getDataFolder(),
						"registrations.yml");
			}
			plugin.playersConfig = YamlConfiguration
					.loadConfiguration(plugin.playersConfigFile);

			// Look for defaults in the jar
			InputStream defConfigStream = plugin.getResource("registrations.yml");
			if (defConfigStream != null) {
				YamlConfiguration defConfig = YamlConfiguration
						.loadConfiguration(defConfigStream);
				plugin.playersConfig.setDefaults(defConfig);
			}
		}

		protected FileConfiguration getRegistrationsConfig() {
			if (plugin.playersConfig == null) {
				this.reloadRegistrationsConfig();
			}
			return plugin.playersConfig;
		}

		public void saveRegistrationsConfig() {
			if (plugin.playersConfig == null || plugin.playersConfigFile == null) {
				return;
			}
			try {
				getRegistrationsConfig().save(plugin.playersConfigFile);
			} catch (IOException ex) {
				plugin.getLogger().log(Level.SEVERE,
						"Could not save config to " + plugin.playersConfigFile, ex);
			}
		}
		
		public void loadConfiguration() {
			reloadRegistrationsConfig();
			plugin.getConfig().options().header("SimpleRegister v" + plugin.getDescription().getVersion() + " Config ----- COMMANDS WITHOUT A '/'!!!!" +
					"\nE-mailer only supports gmail accounts at the moment.");
			plugin.getConfig().addDefault("Servername", "Server Name Here");
			plugin.getConfig().addDefault("Commands.Use Accept Alias", false);
			plugin.getConfig().addDefault("Commands.Use Deny Alias", false);
			plugin.getConfig().addDefault("Commands.Use View Alias", false);
			plugin.getConfig().addDefault("EmailAPI.use", false);
			plugin.getConfig().addDefault("EmailAPI.emailQuestion", "Question1");
			plugin.getConfig().addDefault("EmailAPI.username", "username@gmail.com");
			plugin.getConfig().addDefault("EmailAPI.password", "mypassword");
			plugin.getConfig().addDefault("EmailAPI.subjectofemail", "Your registration on %servername% has been approved!");
			plugin.getConfig().addDefault("EmailAPI.bodyofemail", "You had registered at %servername% and your application has been approved! You can now go to www.example.com/mcserver to view our website!" +
					"\nYou can also use the \\n to create a new line.");
			
			
			if (plugin.getConfig().getList("CommandsToExecuteOnApproval") == null) {
			plugin.getConfig().set("CommandsToExecuteOnApproval", Arrays.asList(stringArray));
			List<String> commands = plugin.getConfig().getStringList(
					"CommandsToExecuteOnApproval");
			commands.add("give %player% 1 64");
			plugin.getConfig().set("CommandsToExecuteOnApproval", commands);
			plugin.saveConfig();
			}
			if (plugin.getConfig().getList("CommandsToExecuteOnDecline") == null) {
				plugin.getConfig().set("CommandsToExecuteOnDecline", Arrays.asList(stringArray));
				List<String> commands = plugin.getConfig().getStringList(
						"CommandsToExecuteOnDecline");
				commands.add("tell %player% Your application has been declined.");
				plugin.getConfig().set("CommandsToExecuteOnDecline", commands);
				plugin.saveConfig();
				}
			if (plugin.playersConfig.getList("PendingApplications") == null) {
			plugin.playersConfig.set("PendingApplications", Arrays.asList(stringArray));
			saveRegistrationsConfig();
			}
			// Initialize Questions
			plugin.getConfig().addDefault("Question1.Question", "What is your e-mail address?"); // Question
			plugin.getConfig().addDefault("Question1.Use", true); // Do we use it?
			
			plugin.getConfig().addDefault("Question2.Question", "How old are you?");
			plugin.getConfig().addDefault("Question2.Use", true);
			
			plugin.getConfig().addDefault("Question3.Question", "How did you find out about %servername%?");
			plugin.getConfig().addDefault("Question3.Use", true);
			
			plugin.getConfig().addDefault("Question4.Question", "Question here");
			plugin.getConfig().addDefault("Question4.Use", false);
			
			plugin.getConfig().addDefault("Question5.Question", "Question here");
			plugin.getConfig().addDefault("Question5.Use", false);
			
			plugin.getConfig().addDefault("Question6.Question", "Question here");
			plugin.getConfig().addDefault("Question6.Use", false);
			
			plugin.getConfig().addDefault("Question7.Question", "Question here");
			plugin.getConfig().addDefault("Question7.Use", false);
			
			plugin.getConfig().addDefault("Question8.Question", "Question here");
			plugin.getConfig().addDefault("Question8.Use", false);
			
			plugin.getConfig().addDefault("Question9.Question", "Question here");
			plugin.getConfig().addDefault("Question9.Use", false);
			
			plugin.getConfig().addDefault("Question10.Question", "Question here");
			plugin.getConfig().addDefault("Question10.Use", false);
			
			
			if (plugin.playersConfig.getList("DeclinedApplications") == null) {
				plugin.playersConfig.set("DeclinedApplications", Arrays.asList(stringArray));
				saveRegistrationsConfig();
			}
			plugin.Question1 = plugin.getConfig().getString("Question1.Question");
			plugin.Question2 = plugin.getConfig().getString("Question2.Question");
			plugin.Question3 = plugin.getConfig().getString("Question3.Question");
			plugin.Question4 = plugin.getConfig().getString("Question4.Question");
			plugin.Question5 = plugin.getConfig().getString("Question5.Question");
			plugin.Question6 = plugin.getConfig().getString("Question6.Question");
			plugin.Question7 = plugin.getConfig().getString("Question7.Question");
			plugin.Question8 = plugin.getConfig().getString("Question8.Question");
			plugin.Question9 = plugin.getConfig().getString("Question9.Question");
			plugin.Question10 = plugin.getConfig().getString("Question10.Question");
			
			plugin.getConfig().options().copyDefaults(true);
			plugin.saveConfig();
		}
		
		public void readInfo(String playername) {
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value1") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value1", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value2") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value2", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value3") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value3", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value4") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value4", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value5") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value5", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value6") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value6", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value7") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value7", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value8") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value8", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value9") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value9", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".value10") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".value10", "");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".Registered") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".Registered", false);
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
			if (plugin.playersConfig.get(playername.toLowerCase() + ".Status") == null) {
				plugin.playersConfig.set(playername.toLowerCase() + ".Status", "notregistered");
				plugin.loadConfiguration.saveRegistrationsConfig();
			}
		}
}